AppTitle "Star Strike"

SeedRnd MilliSecs()
Graphics3D 800,600,16,2
SetBuffer BackBuffer()

;TYPES
Type pft
	Field entity,life
End Type

Type stt
	Field entity,shadow,silo
End Type

Type ext
	Field entity,alpha#,faderate#,size#,sizerate#,trench
End Type

Type pat
	Field cx#,cy#,cz#,r#,g#,b#,cr#,cg#,cb#,life,gravity,sprite,trench
End Type

Type exrt
	Field sprite,alpha#,faderate#,size#,sizerate#,trench
End Type

Type saucert
	Field entity,leftshadow,rightshadow,groundshadow,hp,mx#,my#,mz#,deadmeat,dx#,dy#,dz#
End Type

Type eft
	Field sprite,life
End Type

FrameTimer=CreateTimer(60)

;COLLISIONS
Const Coll_player=1
Const Coll_trench=2
Const Coll_earth=3
Const Coll_planetdestroyer=4
Const Coll_silo=5
Const Coll_bomb=6
Const Coll_saucer=7
Const Coll_playershot=8
Const Coll_saucershot=9
Collisions Coll_planetDestroyer,Coll_earth,1,1
Collisions Coll_bomb,Coll_silo,2,1
Collisions Coll_playershot,Coll_saucer,2,1
Collisions Coll_saucershot,Coll_player,3,1

;FONTS
Global LargeFont=LoadFont("Arial.fnt",60,True,False,False)
Global MediumFont=LoadFont("Arial.fnt",40,True,False,False)
Global SmallFont=LoadFont("Arial.fnt",20,True,False,False)

;TEXTURES
Global TrenchTex=LoadTexture("Textures\trench.jpg"):ScaleTexture TrenchTex,0.01,0.01
Global StarFieldTex=LoadTexture("Textures\starfield.jpg"):ScaleTexture StarFieldTex,0.2,0.2
Global EarthTex=LoadTexture("Textures\earth2.jpg")
Global MoonTex=LoadTexture("Textures\moon.jpg")
Global AlienStationTex=LoadTexture("Textures\alienstation.jpg")
Global TrenchSiloTex=LoadTexture("Textures\trenchsilo.jpg")
Global TrenchSiloRuinedTex=LoadTexture("Textures\trenchsiloruined.jpg")
Global PlayerShipTex=LoadTexture("Textures\playership.jpg")
Dim BuildTex(6)
For a=1 To 6
	BuildTex(a)=LoadTexture("Textures\build"+a+".jpg")
Next
Global BombTex=LoadTexture("Textures\bomb.jpg")
Global UFOTex=LoadTexture("Textures\ufo.jpg")

;MESHES
Global TrenchMesh=LoadMesh("Meshes\trench.b3d"):ScaleEntity TrenchMesh,10,10,10:EntityTexture TrenchMesh,TrenchTex:EntityType TrenchMesh,Coll_trench:HideEntity TrenchMesh
Global StarFieldMesh=CreateSphere(32):ScaleEntity StarFieldMesh,29000,29000,29000:EntityTexture StarFieldMesh,StarFieldTex:EntityFX StarFieldMesh,5:FlipMesh StarFieldMesh
Global EarthMesh=CreateSphere(32):ScaleEntity EarthMesh,2000,2000,2000:EntityTexture EarthMesh,EarthTex:EntityRadius EarthMesh,2000:HideEntity EarthMesh
	EntityType EarthMesh,coll_earth
Global MoonMesh=CreateSphere(32):ScaleEntity MoonMesh,10000,10000,10000:EntityTexture MoonMesh,MoonTex:HideEntity MoonMesh
Global AlienStationMesh=CreateSphere(32):ScaleEntity AlienStationMesh,200,200,200:EntityTexture AlienStationMesh,AlienStationTex:HideEntity AlienStationMesh
Global PlayerMesh=LoadMesh("Meshes\PlayerShip.b3d"):ScaleEntity PlayerMesh,0.2,0.2,0.2:EntityTexture PlayerMesh,PlayerShipTex:HideEntity PlayerMesh
	EntityBox PlayerMesh,-10,-10,-5,20,20,10:EntityType PlayerMesh,Coll_player
Global PlayerFireMesh=LoadMesh("Meshes\PlayerFire.b3d"):ScaleEntity PlayerFireMesh,0.1,0.1,0.1:HideEntity PlayerFireMesh:EntityRadius PlayerFireMesh,1
	EntityFX PlayerFireMesh,5:EntityColor PlayerFireMesh,255,0,0
Dim BuildMesh(6)
For a=1 To 6
	BuildMesh(a)=LoadMesh("Meshes\Build"+a+".b3d")
	ScaleEntity BuildMesh(a),0.5,0.2,0.5
	EntityTexture BuildMesh(a),BuildTex(a)
	HideEntity BuildMesh(a)
Next
Global ExplosionMesh=CreateSphere(16):HideEntity ExplosionMesh:EntityFX ExplosionMesh,5
Global TrenchSiloMesh=LoadMesh("Meshes\TrenchSilo.b3d"):EntityTexture TrenchSiloMesh,TrenchSiloTex:ScaleEntity TrenchSiloMesh,0.45,0.25,0.45:HideEntity TrenchSiloMesh:EntityType TrenchSiloMesh,Coll_silo
	EntityBox TrenchSiloMesh,-65,0,-65,130,30,130
Global TrenchSiloRuinedMesh=LoadMesh("Meshes\TrenchSiloRuined.b3d"):EntityTexture TrenchSiloRuinedMesh,TrenchSiloRuinedTex:ScaleEntity TrenchSiloRuinedMesh,0.45,0.25,0.45:HideEntity TrenchSiloRuinedMesh
Global BombMesh=LoadMesh("Meshes\bomb.b3d"):EntityTexture BombMesh,BombTex:HideEntity BombMesh:ScaleEntity BombMesh,0.1,0.1,0.1:EntityRadius BombMesh,8:EntityType BombMesh,Coll_bomb
Global UFOMesh=LoadMesh("Meshes\ufo.b3d"):EntityTexture UFOMesh,UFOTex:HideEntity UFOMesh:EntityShininess UFOMesh,0.8:ScaleEntity UFOMesh,0.3,0.3,0.3
Global ShieldMesh=CreateSphere(16):ScaleEntity ShieldMesh,40,10,20:EntityAlpha ShieldMesh,0:EntityColor ShieldMesh,255,0,0

;SPRITES
Global LensFlareSprite=LoadSprite("Sprites\LensFlare.jpg"):ScaleSprite LensFlareSprite,2,2:HideEntity LensFlareSprite
Dim LensFlares(4)
For a=1 To 4
	LensFlares(a)=CopyEntity(LensFlareSprite):HideEntity LensFlares(a)
Next
Global ParticleSprite=LoadSprite("Sprites\Particle.jpg"):HideEntity ParticleSprite
Global ExplosionRingSprite=LoadSprite("Sprites\ExplosionRing.jpg"):HideEntity ExplosionRingSprite
Global SunSprite=LoadSprite("Sprites\Sun.jpg"):HideEntity SunSprite
Global StarStrikeSprite=LoadSprite("Sprites\StarStrikeTitle.jpg"):HideEntity StarStrikeSprite:EntityFX StarStrikeSprite,1
Global PlanetDestroyerSprite=LoadSprite("Sprites\PlanetDestroyer.jpg"):ScaleSprite PlanetDestroyerSprite,500,500:EntityRadius PlanetDestroyerSprite,50:HideEntity PlanetDestroyerSprite
	EntityType PlanetDestroyerSprite,coll_planetdestroyer:EntityFX PlanetDestroyerSprite,17:SpriteViewMode PlanetDestroyerSprite,2
Global SquareShadowSprite=LoadSprite("Sprites\shadowsquare.jpg"):HideEntity SquareShadowSprite:EntityBlend SquareShadowSprite,2:SpriteViewMode SquareShadowSprite,2
Global RoundShadowSprite=LoadSprite("sprites\shadowround.jpg"):HideEntity RoundShadowSprite:EntityBlend RoundShadowSprite,2:SpriteViewMode RoundShadowSprite,2
Global PlayerGroundShadow=CopyEntity(RoundShadowSprite):ScaleSprite PlayerGroundShadow,50,20
Global LeftPlayerShadow=CopyEntity(SquareShadowSprite):ScaleSprite LeftPlayerShadow,40,20
Global RightPlayerShadow=CopyEntity(SquareShadowSprite):ScaleSprite RightPlayerShadow,40,20
Global BombShadow=CopyEntity(RoundShadowSprite):ScaleSprite BombShadow,20,20:HideEntity BombShadow
Global SiloAlertSprite=LoadSprite("Sprites\SiloAlert.jpg"):EntityAlpha SiloAlertSprite,0
Global GameOverSprite=LoadSprite("Sprites\GameOver.jpg"):HideEntity GameOverSprite:ScaleSprite GameOverSprite,1.5,1.5
Global ChooseDifficultySprite=LoadSprite("Sprites\ChooseDifficulty.jpg"):HideEntity ChooseDifficultySprite:ScaleSprite ChooseDifficultySprite,1.5,1.5
Global VictorySprite=LoadSprite("Sprites\Victory.jpg"):HideEntity VictorySprite:EntityFX VictorySprite,1
Global SaucerShotSprite=LoadSprite("Sprites\SaucerShot.jpg"):HideEntity SaucerShotSprite:ScaleSprite SaucerShotSprite,10,10:EntityRadius SaucerShotSprite,10
Global PressSpaceSprite=LoadSprite("Sprites\PressSpace.jpg"):HideEntity PressSpaceSprite:EntityFX PressSpaceSprite,1

;PIVOTS
Global VanishingPoint=CreatePivot()
Global PlayerPivot=CreatePivot()
Global PlayerFireLocation1=CreatePivot()
Global PlayerFireLocation2=CreatePivot()

;CAMERA
Global Camera=CreateCamera():CameraRange Camera,1,50000

;LIGHTS
Global Light1=CreateLight(2):LightColor Light1,255,255,255:LightRange Light1,1000
Global Light2=CreateLight(2):LightColor Light2,255,255,255:LightRange Light2,1000

;SOUNDS
Global TitleMusic=LoadSound("Audio\TitleMusic.mp3")
Global VictoryMusic=LoadSound("Audio\StarStrikeVictory.mp3")
Global EvilLaughSound=LoadSound("Audio\EvilLaugh.mp3")
Global PlayerEngineSound=LoadSound("Audio\PlayerEngines.wav"):LoopSound PlayerEngineSound
Global PlayerEnginesChannel=PlaySound(PlayerEngineSound):ChannelVolume PlayerEnginesChannel,0
Global PlayerShootSound=LoadSound("Audio\PlayerShoot.mp3"):SoundVolume PlayerShootSound,0.3
Global SiloExplosionSound=LoadSound("Audio\SiloExplosion.mp3")
Global PlanetExplosionSound=LoadSound("Audio\PlanetExplosion.mp3")
Global SmallExplosionSound=LoadSound("Audio\SmallExplosion.mp3"):SoundVolume SmallExplosionSound,0.3
Global MediumExplosionSound=LoadSound("Audio\MediumExplosion.mp3")
Global BombFallSound=LoadSound("Audio\BombFalling.mp3"):SoundVolume BombFallSound,0.15
Global PlanetDestroyerLaunchSound=LoadSound("Audio\PlanetDestroyerLaunch.mp3")
Global SiloAlertSound=LoadSound("Audio\SiloAlertAlarm.mp3"):SoundVolume SiloAlertSound,0.70
Global BombFallChannel,PlanetDestroyerLaunchChannel
Global SaucerShootSound=LoadSound("Audio\UFOShoot.mp3"):SoundVolume SaucerShootSound,0.5

;GAME VARIABLES
Const Gravity#=0.1
Const DistanceBetweenSilos=5000

Dim SiloDestroyed(5)
Dim MinPlayerSpeed#(4),MaxPlayerSpeed#(4),SaucerShootSpeed(4),EarthSpeed(4),MaxSaucers(4),FreqSaucers(4)
Global Difficulty,PlayerSpeed#,TrenchScroll#,pow,StructureTimer,ShakeAmt#,CurShakeTimer,MaxShakeTimer,ShieldHP,ShieldAlpha#
Global CurrSilo,NextSiloDistance#,PlanetDestroyerLaunched,EarthBoomTimer,DeathTimer
Global BombDropped,TumbleX#,TumbleY#,TumbleZ#,SiloAlertFlash#,SiloAdded,SilosDestroyed,Score

.DifficultyConstants
;MinPlayerSpeed
Data 0.05,0.07,0.10,0.10
;MaxPlayerSpeed
Data 0.15,0.18,0.20,0.20
;EarthSpeed
Data 1,3,20,20
;SaucerShootSpeed
Data 150,100,75,75
;MaxSaucers
Data 2,3,5,5
;FreqSaucers
Data 100,100,100,100

RestartGame
	
While Not KeyDown(1)
	PollPlayerControls
	UpdatePlayer
	UpdatePlayerShots
	UpdatePlayerBomb
	UpdateSaucers
	UpdateSaucerShots
	UpdateBattleField
	
	If Rand(1,4)=1 Then
		If NextSiloDistance>2000+150 Or NextSiloDistance<2000-150 Then AddStructure(Rand(-90,90),2000,Rand(1,6))
	EndIf
	
	If Rand(1,FreqSaucers(Difficulty))=1 And DeathTimer=0 And PlanetDestroyerLaunched=False Then AddSaucer
	
	If DeathTimer=100 Then PositionEntity Camera,0,100,0,True
	If DeathTimer>0 Then AccelPlayer
	
	If Difficulty<>4 Then ChangeScore(-2)
	
	WaitTimer(FrameTimer)
	UpdateWorld
	RenderWorld
	UpdateHUD	
	Flip
Wend

Function UpdateHUD()
	SetFont(MediumFont)
	Color 150,150,150:Text 12,15,Score
	For a=1 To ShieldHP:Text 625+(a*15),15,Chr(176):Next	
	Color 255,255,255:Text 10,13,Score	
	For a=1 To ShieldHP:Text 623+(a*15),13,Chr(176):Next
End Function

Function ChangeScore(h)
	Score=Score+h
	If Difficulty<>4 And Score>9999 Then Score=9999
	If Score<0 Then Score=0
End Function


Function RestartGame()
	ClearAllMiscEntities
	InitializeVariables
	TitleScreen
	ChooseDifficulty
	SetUpBattleField
	PlayerSpeed=MinPlayerSpeed(Difficulty)
	If Difficulty=4 Then Score=0 Else Score=9999
End Function

Function TitleScreen()
	;Setup
	HideEntity MoonMesh:HideEntity TrenchMesh:HideEntity GameOverSprite:HideEntity VictorySprite:HideEntity BombMesh
	EntityParent Camera,0
	
	PositionEntity StarFieldMesh,0,0,0
	MoonMesh2=CopyEntity(MoonMesh):PositionEntity MoonMesh2,-1000,4500,9000:ScaleEntity MoonMesh2,1000,1000,1000:RotateEntity MoonMesh2,0,45,0
	ShowEntity AlienStationMesh:PositionEntity AlienStationMesh,600,4500,9000
	glow=CopyEntity(ParticleSprite):ScaleSprite glow,500,500:PositionEntity glow,600,4500,9000
	ShowEntity EarthMesh:PositionEntity EarthMesh,-1000,-2000,-2000:RotateEntity EarthMesh,0,0,21:TurnEntity EarthMesh,0,Rand(0,359),0
	ShowEntity SunSprite:ScaleSprite SunSprite,450,450:PositionEntity SunSprite,4000,0,1000
	light3=CreateLight(2):LightRange light3,12000:PositionEntity light3,7000,0,4000
	ShowEntity StarStrikeSprite:ScaleSprite StarStrikeSprite,100,150:PositionEntity StarStrikeSprite,-150,50,-3750
	ShowEntity PressSpaceSprite:ScaleSprite PressSpaceSprite,200,200:PositionEntity PressSpaceSprite,0,30,-3750
	PositionEntity Camera,0,0,-4000:RotateEntity Camera,0,0,0
	g#=0.5:gr#=0.01
	LoopSound(TitleMusic)
	m=PlaySound(TitleMusic)
	FlushKeys
	Repeat
		kk=GetKey()
		TurnEntity EarthMesh,0,0.01,0
		TurnEntity AlienStationMesh,0,0.1,0
		g=g+gr
		If g>1 Then g=1:gr=gr*-1
		If g<0.5 Then g=0.5:gr=gr*-1
		EntityAlpha glow,g
		
		UpdateWorld
		RenderWorld
		Flip
	Until kk=32
	FreeEntity MoonMesh2:HideEntity AlienStationMesh:HideEntity StarStrikeSprite:FreeEntity glow:FreeEntity light3:HideEntity SunSprite:HideEntity PressSpaceSprite
	StopChannel m
	Cls:Flip	
End Function

Function ChooseDifficulty()
	Cls
	PositionEntity Camera,0,0,0:RotateEntity Camera,0,0,0
	ShowEntity ChooseDifficultySprite:PositionEntity ChooseDifficultySprite,-0.2,0,2
	UpdateWorld:RenderWorld:Flip
	FlushKeys
	Repeat
		kk=GetKey()
		If kk>=49 And kk<=52 Then Difficulty=kk-48:Return
	
	Forever
End Function

Function InitializeVariables()
	TrenchScroll=0
	CurrSilo=1:NextSiloDistance=DistanceBetweenSilos:SilosDestroyed=0:DeathTimer=0:ShieldHP=10
	PlanetDestroyerLaunched=False:EarthBoomTimer=0:BombDropped=False:SiloAlertFlash=0:SiloAdded=False
	ShieldAlpha=0:VictoryTimer=0:CurShakeTimer=0
	For a=1 To 5:SiloDestroyed(a)=False:Next
	Restore DifficultyConstants
	For a=1 To 4:Read MinPlayerSpeed(a):Next
	For a=1 To 4:Read MaxPlayerSpeed(a):Next
	For a=1 To 4:Read EarthSpeed(a):Next
	For a=1 To 4:Read SaucerShootSpeed(a):Next
	For a=1 To 4:Read MaxSaucers(a):Next
	For a=1 To 4:Read FreqSaucers(a):Next
End Function

Function PollPlayerControls()
	If PlanetDestroyerLaunched=True Then Return
	If DeathTimer>0 Then Return
	If KeyDown(1) Then End
	
	kk=GetKey()
	
	;Movement
	;Up
	If KeyDown(208) And EntityY(PlayerPivot)<=200 Then 
		MoveEntity PlayerPivot,0,5,0
		TurnEntity PlayerMesh,-1,0,0
	EndIf
	;Down
	If KeyDown(200) Then 
		MoveEntity PlayerPivot,0,-5,0
		TurnEntity PlayerMesh,1,0,0
	EndIf
	;Left
	If KeyDown(203) And EntityX(PlayerPivot)>=-250 Then 
		MoveEntity PlayerPivot,-5,0,0
		TurnEntity PlayerMesh,0,1,1
	EndIf
	;Right
	If KeyDown(205) And EntityX(PlayerPivot)<=250 Then 
		MoveEntity PlayerPivot,5,0,0
		TurnEntity PlayerMesh,0,-1,-1
	EndIf

	;Speed up
	If KeyDown(30) Then AccelPlayer
	;Speed down
	If KeyDown(44) Then DecelPlayer
	
	;Fire!
	If kk=32 Then PlayerFires
	
	;Bomb!
	If kk=Asc("b") Or kk=Asc("B") Then AddPlayerBomb

	;Pause
	If kk=Asc("p") Or kk=Asc("P") Then
		SetFont(LargeFont)
		Color 150,150,150
		Text 405,305,"PAUSED",True,True
		Color 255,255,255
		Text 400,300,"PAUSED",True,True
		Flip
		FlushKeys
		Repeat
			kk=GetKey()
		Until kk=Asc("p") Or kk=Asc("P")
		Flip
		FlushKeys
	EndIf

End Function

Function AccelPlayer()
	PlayerSpeed=PlayerSpeed+0.0005
	If PlayerSpeed>MaxPlayerSpeed(Difficulty) Then PlayerSpeed=MaxPlayerSpeed(Difficulty)
	p#=22050+(PlayerSpeed*300000)
	ChannelPitch PlayerEnginesChannel,p
End Function

Function DecelPlayer()
	PlayerSpeed=PlayerSpeed-0.0005
	If PlayerSpeed<MinPlayerSpeed(Difficulty) Then PlayerSpeed=MinPlayerSpeed(Difficulty)
	p#=22050+(PlayerSpeed*300000)
	ChannelPitch PlayerEnginesChannel,p	
End Function

Function UpdateBattleField()
	TurnEntity MoonMesh,0,-0.01,0
	TurnEntity EarthMesh,0,0.05,0
	If EntityX(EarthMesh)<0 Then 
		If DeathTimer=0 Then TranslateEntity EarthMesh,EarthSpeed(Difficulty),0,0 Else TranslateEntity EarthMesh,20,0,0
	EndIf
	TrenchScroll=TrenchScroll+PlayerSpeed
	PositionTexture TrenchTex,0,TrenchScroll
	If TrenchScroll>=1 Then TrenchScroll=TrenchScroll-1
	PointEntity PlayerPivot,VanishingPoint
	
	For st.stt=Each stt
		TranslateEntity st\entity,0,0,-70*PlayerSpeed
		TranslateEntity st\shadow,0,0,-70*PlayerSpeed
		If EntityZ(st\entity)<0 Then 
			If st\silo=True And EarthBoomTimer=0 Then LaunchPlanetDestroyer
			FreeEntity st\entity
			FreeEntity st\shadow
			Delete st
		EndIf
	Next
	
	NextSiloDistance=NextSiloDistance-(70*PlayerSpeed)
	If NextSiloDistance<=2000 And SiloAdded=False Then
		SiloAdded=True
		If SiloDestroyed(CurrSilo)=True Then 
			AddStructure(0,2000,8) 
		Else
			AddStructure(0,2000,7)
		EndIf
	EndIf
	If NextSiloDistance<=0 Then
		NextSiloDistance=DistanceBetweenSilos
		CurrSilo=CurrSilo+1:If CurrSilo>5 Then CurrSilo=1
		SiloAdded=False
	EndIf

	
	UpdateExplosions
	UpdateParticles
	UpdateExplosionRings
	UpdatePlanetDestroyer
	If EarthBoomTimer>0 And EarthBoomTimer<1000 Then
		AccelPlayer
		EarthBoomTimer=EarthBoomTimer+1
		If EarthBoomTimer=25 Then HideEntity EarthMesh
		If EarthBoomTimer=120 Then PlaySound EvilLaughSound
	EndIf
End Function

Function UpdatePlayer()
	If DeathTimer>0 And DeathTimer<1000 Then DeathTimer=DeathTimer+1
	
	If EntityPitch(PlayerMesh)>0.1 Then TurnEntity PlayerMesh,-0.5,0,0
	If EntityPitch(PlayerMesh)<0.1 Then TurnEntity PlayerMesh,0.5,0,0
	If EntityYaw(PlayerMesh)>0.1 Then TurnEntity PlayerMesh,0,-0.5,0
	If EntityYaw(PlayerMesh)<0.1 Then TurnEntity PlayerMesh,0,0.5,0
	If EntityRoll(PlayerMesh)>0.1 Then TurnEntity PlayerMesh,0,0,-0.5
	If EntityRoll(PlayerMesh)<0.1 Then TurnEntity PlayerMesh,0,0,0.5
	
	ShieldAlpha=ShieldAlpha-0.025
	If ShieldAlpha<0 Then ShieldAlpha=0
	EntityAlpha ShieldMesh,ShieldAlpha
	
	x=EntityX(PlayerPivot):y=EntityY(PlayerPivot):z=EntityZ(PlayerPivot)
	;If IsPointCollidingWithTrench(x,y,z)=True Then Pow=True 
	;If IsPointCollidingWithTrench(x-35,y,z)=True Then Pow=True 
	;If IsPointCollidingWithTrench(x+35,y,z)=True Then Pow=True
	
	RotateEntity PlayerGroundShadow,90,0,0
	If EntityX(PlayerMesh,True)>=100 Or EntityX(PlayerMesh,True)<=-100 Then alt#=100.5 Else alt#=0.5
	PositionEntity PlayerGroundShadow,EntityX(PlayerMesh,True),alt,200
	
	If EntityY(PlayerMesh,True)<95 And PlanetDestroyerLaunched=False And DeathTimer=0 Then
		ShowEntity LeftPlayerShadow
		ShowEntity RightPlayerShadow
		RotateEntity LeftPlayerShadow,0,90,0
		PositionEntity LeftPlayerShadow,-99.5,EntityY(PlayerMesh,True),200
		RotateEntity RightPlayerShadow,0,-90,0
		PositionEntity RightPlayerShadow,99.5,EntityY(PlayerMesh,True),200
	Else
		HideEntity LeftPlayerShadow
		HideEntity RightPlayerShadow
	EndIf
	
	If IsPointCollidingWithTrench(x,y,z)=True Then TranslateEntity PlayerPivot,0,5,0:DamagePlayer(100)
	If IsPointCollidingWithTrench(x-35,y,z)=True Then DamagePlayer(100)
	If IsPointCollidingWithTrench(x+35,y,z)=True Then DamagePlayer(100)
	
	For a=1 To 4
		ScaleSprite LensFlares(a),PlayerSpeed*40,PlayerSpeed*40
	Next
	
	If CurShakeTimer>0 Then
		CurShakeTimer=CurShakeTimer-1
		oldx#=EntityX(Camera):oldy#=EntityY(Camera):oldz#=EntityZ(Camera)
		PositionEntity Camera,0,0,-100
		PositionEntity Camera,Rnd(-ShakeAmt,ShakeAmt),Rnd(-ShakeAmt,ShakeAmt),-100+Rnd(-ShakeAmt,ShakeAmt)
		If CurShakeTimer<=0 Then PositionEntity Camera,0,0,-100
	EndIf

	If NextSiloDistance<2000 And SiloDestroyed(CurrSilo)=False And PlanetDestroyerLaunched=False And DeathTimer=0 Then
		SiloAlertFlash=SiloAlertFlash+5
		If SiloAlertFlash>=360 Then SiloAlertFlash=0:PlaySound SiloAlertSound
	 	EntityAlpha SiloAlertSprite,Sin(SiloAlertFlash)
	Else
		EntityAlpha SiloAlertSprite,0
	EndIf 
	If EarthBoomTimer>450 Then 
		ShowEntity GameOverSprite
		If KeyDown(57) Then RestartGame
	EndIf
End Function

Function DamagePlayer(dam)
	If DeathTimer>0 Then Return
	ShieldHP=ShieldHP-dam
	If ShieldHP>-1 Then Return
	
	AddExplosionRing(EntityX(PlayerMesh,True),EntityY(PlayerMesh,True),EntityZ(PlayerMesh,True),0,0,0,0.01,1,False)
	AddExplosion(EntityX(PlayerMesh,True),EntityY(PlayerMesh,True),EntityZ(PlayerMesh,True),255,255,255,0.02,1,False)

	HideEntity PlayerMesh:HideEntity LeftPlayerShadow:HideEntity RightPlayerShadow:HideEntity PlayerGroundShadow
	DeathTimer=1:EntityAlpha SiloAlertSprite,0:BombDropped=False:HideEntity BombMesh
	ChannelVolume PlayerEnginesChannel,0:If Difficulty<>4 Then ChangeScore(-9999)
	PlaySound MediumExplosionSound
	StopChannel BombFallChannel:HideEntity BombMesh:HideEntity BombShadow
	For saucer.saucert=Each saucert
		saucer\deadmeat=True
	Next
	
	For a=1 To 20
		ang1=Rand(0,359)
		ang2=Rand(0,359)
		spp#=Rnd(0,2)
		cx#=Sin(ang1)*spp
		cy#=-Cos(ang1)*spp
		cz#=Rnd(-spp,spp)
		cz#=0	
		AddParticle(EntityX(PlayerMesh,True),EntityY(PlayerMesh,True),EntityZ(PlayerMesh,True),cx,cy,cz,255,255,255,-Rnd(1,2),-Rnd(2,4),-Rnd(4,8),220,Rnd(2,5),False,False)
	Next

		
End Function

Function IsPointCollidingWithTrench(x,y,z)
	If y>100 Then Return False
	If y<=0 Then Return True
	If x>100 Or x<-100 Then Return True
	Return False
End Function

Function SetUpBattleField()
	ShowEntity MoonMesh:ShowEntity EarthMesh:ShowEntity TrenchMesh:ShowEntity PlayerMesh
	HideEntity GameOverSprite
	PositionEntity TrenchMesh,0,0,0,True:RotateEntity TrenchMesh,0,180,0
	PositionEntity StarFieldMesh,0,0,1000,True
	PositionEntity MoonMesh,-14000,3000,8000,True:RotateEntity MoonMesh,0,Rnd(0,359),0
	PositionEntity EarthMesh,-8300,7500,14000,True:RotateEntity EarthMesh,-21,0,21:TurnEntity EarthMesh,0,Rnd(0,359),0
	PositionEntity VanishingPoint,0,100,5000,True
	
	EntityParent PlayerMesh,0
	EntityParent PlayerFireLocation1,0:EntityParent PlayerFireLocation2,0
	EntityParent PlayerPivot,0:EntityParent Camera,0:EntityParent ShieldMesh,0
	EntityParent SiloAlertSprite,0:EntityParent GameOverSprite,0
	
	PositionEntity PlayerMesh,0,100,200,True:RotateEntity PlayerMesh,0,0,0
	PositionEntity ShieldMesh,0,100,200,True
	PositionEntity PlayerPivot,0,100,200,True
	PositionEntity Camera,0,100,100,True
	PositionEntity SiloAlertSprite,0,100.7,102,True
	PositionEntity GameOverSprite,0,100.5,102,True
	PositionEntity PlayerFireLocation1,-16,100,200,True
	PositionEntity PlayerFireLocation2,16,100,200,True
	PositionEntity LensFlares(1),-2,101,182.5,True
	PositionEntity LensFlares(2),-2,99,182.5,True
	PositionEntity LensFlares(3),2,101,182.5,True
	PositionEntity LensFlares(4),2,99,182.5,True
	
	EntityParent PlayerFireLocation1,PlayerMesh
	EntityParent PlayerFireLocation2,PlayerMesh
	For a=1 To 4:EntityParent LensFlares(a),PlayerMesh:ShowEntity LensFlares(a):Next
	
	EntityParent ShieldMesh,PlayerMesh
	EntityParent PlayerMesh,PlayerPivot
	EntityParent Camera,PlayerPivot
	EntityParent SiloAlertSprite,Camera
	EntityParent GameOverSprite,Camera
	EntityRadius PlayerPivot,10
	
	PositionEntity Light1,0,300,0,True
	PositionEntity Light2,0,-300,0,True
	For a=0 To 2000 Step 20
		AddStructure(Rand(-90,90),a,Rand(1,6))
	Next
	ChannelVolume PlayerEnginesChannel,1
End Function

Function ScreenShake(amt,time)
	ShakeAmt=amt
	MaxShakeTimer=time
	CurShakeTimer=time
End Function

Function PlayerFires()
	x1=EntityX(PlayerFireLocation1,True)
	y1=EntityY(PlayerFireLocation1,True)
	z1=EntityZ(PlayerFireLocation1,True)
	ax=EntityPitch(PlayerMesh)
	ay=EntityYaw(PlayerMesh)
	az=EntityRoll(PlayerMesh)
	x2=EntityX(PlayerFireLocation2,True)
	y2=EntityY(PlayerFireLocation2,True)
	z2=EntityZ(PlayerFireLocation2,True)
	AddPlayerShot(x1,y1,z1,ax,ay,az)
	AddPlayerShot(x2,y2,z2,ax,ay,az)
End Function

Function AddPlayerShot(x,y,z,ax,ay,az)
	pf.pft=New pft
	pf\entity=CopyEntity(PlayerFireMesh)
	EntityType pf\entity,Coll_playershot
	PositionEntity pf\entity,x,y,z
	RotateEntity pf\entity,ax,ay,az
	pf\life=100
	PlaySound PlayerShootSound
End Function

Function UpdatePlayerShots()
	For pf.pft=Each pft
		MoveEntity pf\entity,0,0,25
		pf\life=pf\life-1
		If pf\life<=0 Then FreeEntity pf\entity:Delete pf:Goto donepf
		x=EntityX(pf\entity):y=EntityY(pf\entity):z=EntityZ(pf\entity)
		If IsPointCollidingWithTrench(x,y,z)=True Then 
			AddExplosion(x,y,z,255,255,0,0.03,1,True)
			PlaySound SmallExplosionSound
			pp=Rand(3,5)
			For a=1 To pp
				AddParticle(x,y,z,Rnd(-3,3),Rnd(2,5),Rnd(-3,3),255,255,255,-2,-5,-10,100,5,True,True)
			Next
			FreeEntity pf\entity:Delete pf:Goto donepf
		EndIf
		ncol=CountCollisions(pf\entity)
		If ncol>0 Then
			For coll=1 To ncol
				For saucer.saucert=Each saucert
					If saucer\entity=CollisionEntity(pf\entity,coll) Then
						cx#=CollisionX(pf\entity,coll)
						cy#=CollisionY(pf\entity,coll)
						cz#=CollisionZ(pf\entity,coll)
						AddExplosion(cx,cy,cz,255,255,100,0.05,1,False)
						If saucer\deadmeat=False Then DamageSaucer(saucer,1)
						PlaySound SmallExplosionSound
						FreeEntity pf\entity:Delete pf:Goto donepf
					EndIf
				Next			
			Next
		EndIf
		.donepf
	Next
End Function

Function AddStructure(x,z,typ)
	st.stt=New stt
	If typ>=1 And typ<=6 Then st\entity=CopyEntity(BuildMesh(typ)):st\silo=False
	If typ=7 Then st\entity=CopyEntity(TrenchSiloMesh):st\silo=True
	If typ=8 Then st\entity=CopyEntity(TrenchSiloRuinedMesh):st\silo=False
	PositionEntity st\entity,x,0,z
	RotateEntity st\entity,0,90*(Rand(1,4)),0
	EntityAutoFade st\entity,1500,2000
	st\shadow=CopyEntity(SquareShadowSprite)
	PositionEntity st\shadow,x+10,0.1,z
	RotateEntity st\shadow,90,0,0
	If typ=7 Or typ=8 Then ScaleSprite st\shadow,150,150 Else ScaleSprite st\shadow,50,50
	EntityAutoFade st\shadow,1500,2000
End Function

Function AddExplosion(x,y,z,r,g,b,faderate#,sizerate#,trench)
	ex.ext=New ext
	ex\entity=CopyEntity(ExplosionMesh)
	ex\alpha=1:ex\faderate=faderate:ex\size=3:ex\sizerate=sizerate:ex\trench=trench
	ScaleEntity ex\entity,3,3,3
	PositionEntity ex\entity,x,y,z
	EntityColor ex\entity,r,g,b
End Function

Function UpdateExplosions()
	For ex.ext=Each ext
		ex\alpha=ex\alpha-ex\faderate
		ex\size=ex\size+ex\sizerate
		If ex\alpha<=0 Then FreeEntity ex\entity:Delete ex:Goto doneexp
		ScaleEntity ex\entity,ex\size,ex\size,ex\size
		EntityAlpha ex\entity,ex\alpha
		If ex\trench=True Then TranslateEntity ex\entity,0,0,-70*PlayerSpeed
		.doneexp
	Next
End Function

Function AddPlanetExplosion(x,y,z,num,life,sp#,minsize#,maxsize#,numrings)
	For a=1 To num
		ang1=Rand(0,359)
		ang2=Rand(0,359)
		spp#=Rnd(0,sp)
		cx#=Sin(ang1)*spp
		cy#=-Cos(ang1)*spp
		cz#=Rnd(-spp,spp)
		cz#=0
		
		AddParticle(x,y,z,cx,cy,cz,255,255,255,-Rnd(0.5,1),-Rnd(1,2),-Rnd(2,4),life,Rnd(minsize,maxsize),False,False)
	Next
	For a=1 To numrings
		AddExplosionRing(x,y,z,Rand(0,359),Rand(0,359),Rand(0,359),0.005,115,0)
	Next
	AddExplosion(x,y,z,255,255,150,0.015,100,0)
End Function

Function AddParticle(x#,y#,z#,cx#,cy#,cz#,r#,g#,b#,cr#,cg#,cb#,life,size#,gravity,trench)
	pa.pat=New pat
	pa\sprite=CopyEntity(ParticleSprite)
	pa\cx=cx:pa\cy=cy:pa\cz=cz
	pa\r=r:pa\g=g:pa\b=b
	pa\cr=cr:pa\cg=cg:pa\cb=cb
	pa\life=life
	pa\gravity=gravity:pa\trench=trench
	ScaleSprite pa\sprite,size,size	
	PositionEntity pa\sprite,x,y,z
End Function

Function UpdateParticles()
	For pa.pat=Each pat
		If pa\gravity=True Then pa\cy=pa\cy-Gravity
		pa\r=pa\r+pa\cr:pa\g=pa\g+pa\cg:pa\b=pa\b+pa\cb
		If pa\r>255 Then pa\r=255
		If pa\r<0 Then pa\r=0
		If pa\g>255 Then pa\g=255
		If pa\g<0 Then pa\g=0
		If pa\b>255 Then pa\b=255
		If pa\b<0 Then pa\b=0
		EntityColor pa\sprite,pa\r,pa\g,pa\b
		TranslateEntity pa\sprite,pa\cx,pa\cy,pa\cz
		If pa\trench=True Then TranslateEntity pa\sprite,0,0,-70*PlayerSpeed
		pa\life=pa\life-1
		If pa\life<=0 Then FreeEntity pa\sprite:Delete pa:Goto doneparticle
		If pa\r+pa\g+pa\b=0 Then FreeEntity pa\sprite:Delete pa
	.doneparticle
	Next
End Function

Function AddExplosionRing(x,y,z,ax,ay,az,faderate#,sizerate#,trench)
	exr.exrt=New exrt
	exr\sprite=CopyEntity(ExplosionRingSprite)
	exr\size=3:exr\sizerate=sizerate:exr\faderate=faderate
	exr\alpha=1:exr\trench=trench
	PositionEntity exr\sprite,x,y,z
	ScaleSprite exr\sprite,3,3
	SpriteViewMode exr\sprite,2
	EntityFX exr\sprite,16
	RotateEntity exr\sprite,ax,ay,az
End Function

Function UpdateExplosionRings()
	For exr.exrt=Each exrt	
		exr\size=exr\size+exr\sizerate
		exr\alpha=exr\alpha-exr\faderate
		If exr\trench=True Then TranslateEntity exr\sprite,0,0,-70*PlayerSpeed
		If exr\alpha<=0 Then FreeEntity exr\sprite:Delete exr:Goto donerings
		EntityAlpha exr\sprite,exr\alpha
		ScaleSprite exr\sprite,exr\size,exr\size
	.donerings
	Next
End Function

Function LaunchPlanetDestroyer()
	If EntityX(EarthMesh)<0 Then Return
	If PlanetDestroyerLaunched=True Then Return
	ShowEntity PlanetDestroyerSprite:PositionEntity PlanetDestroyerSprite,0,0,0:PointEntity PlanetDestroyerSprite,EarthMesh
	PlanetDestroyerLaunched=True
	PositionEntity Camera,0,100,0,True:HideEntity PlayerMesh
	HideEntity PlayerGroundShadow:HideEntity LeftPlayerShadow:HideEntity RightPlayerShadow
	ChannelVolume PlayerEnginesChannel,0
	PlanetDestroyerLaunchChannel=PlaySound(PlanetDestroyerLaunchSound)
	For saucer.saucert=Each saucert:saucer\deadmeat=True:Next
	If Difficulty<>4 Then ChangeScore(-9999)
End Function

Function UpdatePlanetDestroyer()
	If PlanetDestroyerLaunched=False Or EarthBoomTimer<>0 Then Return
	MoveEntity PlanetDestroyerSprite,0,0,100
	TurnEntity PlanetDestroyerSprite,0,0,3
	If CountCollisions(PlanetDestroyerSprite)>0 Then 
		AddPlanetExplosion(EntityX(PlanetDestroyerSprite),EntityY(PlanetDestroyerSprite),EntityZ(PlanetDestroyerSprite),500,1000,40,150,550,3)
		HideEntity PlanetDestroyerSprite:EarthBoomTimer=1
		StopChannel PlanetDestroyerLaunchChannel
		PlaySound PlanetExplosionSound
	EndIf
End Function

Function AddPlayerBomb()
	If BombDropped=True Then Return
	BombDropped=True
	ShowEntity BombMesh:ShowEntity BombShadow:RotateEntity BombShadow,90,0,0
	x#=EntityX(PlayerMesh,True):y#=EntityY(PlayerMesh,True):z#=EntityZ(PlayerMesh,True)
	PositionEntity BombMesh,x,y,z
	If x>=100 Or x<=-100 Then by#=100.1 Else by#=0.1
	PositionEntity BombShadow,x,by,z
	TumbleX=Rnd(-5,5)
	TumbleY=Rnd(-5,5)
	TumbleZ=Rnd(-5,5)	
	BombFallChannel=PlaySound(BombFallSound)
End Function

Function UpdatePlayerBomb()
	If BombDropped=False Then Return
	TranslateEntity BombMesh,0,-1,2:TranslateEntity BombShadow,0,0,2
	TurnEntity BombMesh,TumbleX,TumbleY,TumbleZ
	x#=EntityX(BombMesh):y#=EntityY(BombMesh):z#=EntityZ(BombMesh)
	If IsPointCollidingWithTrench(x,y,z)=True Then 
		If EntityDistance(BombMesh,PlayerPivot)<50 Then DamagePlayer(100)
		For saucer.saucert=Each saucert
			If EntityDistance(BombMesh,saucer\entity)<50 Then DamageSaucer(saucer,6)
		Next
		HideEntity BombMesh:HideEntity BombShadow:BombDropped=False
		For a=1 To 3
			AddExplosionRing(x,y,z,Rnd(-30,30),Rnd(-30,30),Rnd(-30,30),0.005,3,True)
		Next
		AddExplosion(x,y,z,255,255,255,0.02,3,True)	
		ScreenShake(1,25)
		PlaySound MediumExplosionSound
		StopChannel BombFallChannel
	EndIf
	If CountCollisions(BombMesh)>0 Then 
		For st.stt=Each stt
			If st\silo=True Then
				sx#=EntityX(st\entity)
				sy#=EntityY(st\entity)
				sz#=EntityZ(st\entity)
				FreeEntity st\entity
				st\entity=CopyEntity(TrenchSiloRuinedMesh)
				PositionEntity st\entity,sx,sy,sz
				st\silo=False
			EndIf
		Next
		StopChannel BombFallChannel
		ChangeScore(1000)
		If Difficulty<>4 Then
			SiloDestroyed(currsilo)=True
			SilosDestroyed=SilosDestroyed+1
		EndIf
		For a=1 To 3
			AddExplosionRing(x,y,z,Rnd(-30,30),Rnd(-30,30),Rnd(-30,30),0.005,3,True)
		Next
		AddExplosion(x,y,z,255,255,255,0.02,3,True)	
		AddExplosion(x,y,z,255,255,255,0.02,6,True)
		For a=1 To 150
			AddParticle(x+Rnd(-15,15),y+Rnd(-15,15),z+Rnd(-15,15),Rnd(-3,3),Rnd(1,9),Rnd(-3,3),255,255,255,-1,-1,-1,255,Rand(5,20),True,True)
		Next
		ScreenShake(5+(SilosDestroyed*2),100)
		PlaySound SiloExplosionSound
		If EntityDistance(BombMesh,PlayerPivot)<100 Then DamagePlayer(100)
		For saucer.saucert=Each saucert
			If EntityDistance(BombMesh,saucer\entity)<100 Then DamageSaucer(saucer,6)
		Next
		HideEntity BombMesh:HideEntity BombShadow:BombDropped=False
		If SilosDestroyed=5 Then EntityAlpha SiloAlertSprite,0:VictorySequence
	EndIf
End Function

Function ClearAllMiscEntities()
	;Player Shots
	For pf.pft=Each pft
		FreeEntity pf\entity:Delete pf
	Next
	;Structures
	For st.stt=Each stt
		FreeEntity st\entity:FreeEntity st\shadow:Delete st
	Next
	;Explosions
	For ex.ext=Each ext
		FreeEntity ex\entity:Delete ex
	Next
	;Particles
	For pa.pat=Each pat
		FreeEntity pa\sprite:Delete pa
	Next
	;Explosion Rings
	For exr.exrt=Each exrt
		FreeEntity exr\sprite:Delete exr
	Next
	;Saucers
	For saucer.saucert=Each saucert
		FreeEntity saucer\groundshadow
		FreeEntity saucer\leftshadow
		FreeEntity saucer\rightshadow
		FreeEntity saucer\entity
		Delete saucer
	Next
	;Saucerfire
	For ef.eft=Each eft
		FreeEntity ef\sprite
		Delete ef
	Next
End Function

Function VictorySequence()
	ClearAllMiscEntities
	VictoryTimer=0
	ChannelVolume PlayerEnginesChannel,0
	StopChannel BombFallChannel
	HideEntity PlayerMesh:HideEntity TrenchMesh:HideEntity EarthMesh:HideEntity MoonMesh
	ship2=CopyEntity(PlayerMesh):ScaleEntity ship2,.1,.1,.1:PositionEntity ship2,1500,0,0:RotateEntity ship2,-7,15,0
	ShowEntity AlienStationMesh:MoonMesh2=CopyEntity(MoonMesh):ScaleEntity MoonMesh2,1000,1000,1000:RotateEntity MoonMesh2,0,Rnd(0,359),0
	PositionEntity MoonMesh2,0,0,0:PositionEntity AlienStationMesh,1500,0,0
	PositionEntity Camera,1500,0,0:RotateEntity Camera,0,0,0
	EntityParent VictorySprite,0
	PositionEntity VictorySprite,1500,40,-1,True:ScaleSprite VictorySprite,170,170
	EntityAlpha SiloAlertSprite,0
	PointEntity Camera,AlienStationMesh
	
	While Not KeyDown(1)
		TurnEntity MoonMesh2,0,-0.01,0
		If VictoryTimer>=0 And VictoryTimer<=400 Then
			TurnEntity AlienStationMesh,0,0.2,0
			TranslateEntity Camera,-1.5,0.5,5
			PointEntity Camera,AlienStationMesh
			If Rand(1,10)=1 Then
				If Rand(1,3)=1 Then PlaySound(MediumExplosionSound) Else PlaySound(SmallExplosionSound)
			EndIf
		EndIf
		
		If VictoryTimer Mod 10=0 And VictoryTimer<=400 Then
			a1=Rand(0,359):a2=Rand(0,359)
			ax#=Sin(a1)*150:ay#=-Cos(a1)*150:az#=-Cos(a2)*150
			AddExplosion(1500+ax,0+ay,0+az,255,255,0,0.01,1.5,0)
			For p=1 To 5
				AddParticle(1500,0,0,Rnd(-3,3),Rnd(-3,3),Rnd(-3,3),255,255,255,-1,-2,-4,200,Rand(10,50),False,False)
			Next
		EndIf
		
		If VictoryTimer=401 Then
			PlaySound PlanetExplosionSound
			AddExplosion(1500,0,0,255,255,255,0.005,3,0)
			For p=1 To 250
				a1=Rand(0,359):a2=Rand(0,359):sp#=Rnd(0,6)
				ax#=Sin(a1)*sp:ay=-Cos(a1)*sp:az=Rnd(-6,6)
				AddParticle(1500,0,0,ax,ay,az,255,255,255,Rnd(-0.7,-0.4),Rnd(-1.0,-0.7),Rnd(-3,-1),1000,Rand(50,100),False,False)
			Next
			AddExplosionRing(1500,0,0,0,90,0,0.002,5,0)
		EndIf
		
		If VictoryTimer>200 Then 
			MoveEntity ship2,0,0,10:TurnEntity ship2,0,0,0.25
			AddParticle(EntityX(ship2),EntityY(ship2),EntityZ(ship2),0,0,0,255,100,0,-4,-7,0,200,10,False,False)
		EndIf
		
		If VictoryTimer=430 Then HideEntity AlienStationMesh
		
		If VictoryTimer=600 Then PlaySound VictoryMusic
		
		If VictoryTimer=1 Then EntityParent VictorySprite,Camera
		If VictoryTimer>700 Then 
			ShowEntity VictorySprite
			If KeyDown(57) Then 
				FreeEntity ship2:FreeEntity MoonMesh2
				RestartGame
				Return
			EndIf
		EndIf
		
		If VictoryTimer<1001 Then VictoryTimer=VictoryTimer+1
		UpdateExplosions
		UpdateParticles
		UpdateExplosionRings
		UpdateWorld
		RenderWorld
		Flip
	Wend
End Function

Function AddSaucer()
	a=0
	For saucer.saucert=Each saucert:a=a+1:Next
	If a>=MaxSaucers(Difficulty) Then Return


	If Rand(1,2)=1 Then x=500 Else x=-500
	y=Rnd(130,200):z=Rnd(300,600)
	saucer.saucert=New saucert
	saucer\mx=0:saucer\my=0:saucer\mz=0:saucer\deadmeat=False
	saucer\hp=Rand(1,3)
	saucer\entity=CopyEntity(UFOMesh):EntityType saucer\entity,Coll_saucer
	saucer\groundshadow=CopyEntity(PlayerGroundShadow)
	saucer\leftshadow=CopyEntity(LeftPlayerShadow):RotateEntity saucer\leftshadow,0,90,0
	saucer\rightshadow=CopyEntity(RightPlayerShadow):RotateEntity saucer\rightshadow,0,-90,0
	PositionEntity saucer\entity,x,y,z
	saucer\mx=Rnd(-4,4)
	saucer\my=Rnd(-4,4)
	saucer\mz=Rnd(-4,4)
End Function

Function UpdateSaucers()
	For saucer.saucert=Each saucert
		TurnEntity saucer\entity,0,3,0
		TranslateEntity saucer\entity,saucer\mx,saucer\my,saucer\mz
		x#=EntityX(saucer\entity):y#=EntityY(saucer\entity):z#=EntityZ(saucer\entity)
		
		If saucer\deadmeat=False Then
			If x>250 Then saucer\mx=saucer\mx-0.2
			If x<-250 Then saucer\mx=saucer\mx+0.2
		
			If y>220 Then saucer\my=saucer\my-0.2
			If z>800 Then saucer\mz=saucer\mz-0.2
			If z<250 Then saucer\mz=saucer\mz+0.2
			
			If x>-60 And x<60 And y<25 Then saucer\my=saucer\my+0.3
			If x>=-100 And x<=-60 And y<125 Then saucer\my=saucer\my+0.3:saucer\mx=saucer\mx*0.05
			If x>=60 And x<=100 And y<100 Then saucer\my=saucer\my+0.3:saucer\mx=saucer\mx+0.05
			If (x>100 Or x<-100) And y<125 Then saucer\my=saucer\my+0.2
			
			If y>=125 Then
				If x>EntityX(PlayerMesh,True) Then saucer\mx=saucer\mx-0.05
				If x<EntityX(PlayerMesh,True) Then saucer\mx=saucer\mx+0.05
				If y>EntityY(PlayerMesh,True) Then saucer\my=saucer\my-0.05
				If y<EntityY(PlayerMesh,True) Then saucer\my=saucer\my+0.05
			EndIf
			
			If saucer\deadmeat=False Then
				If saucer\mx>4 Then saucer\mx=4
				If saucer\mx<-4 Then saucer\mx=-4
				If saucer\my>3 Then saucer\my=3
				If saucer\my<-3 Then saucer\my=-3
				If saucer\mz>4 Then saucer\mz=4
				If saucer\mz<-4 Then saucer\mz=-4
			EndIf
		EndIf
		
		
		If saucer\deadmeat=False And Rand(1,SaucerShootSpeed(Difficulty))=1 And DeathTimer=0 Then AddSaucerShot(x,y,z)
		If x>-100 And x<100 Then PositionEntity saucer\groundshadow,x,0.5,z Else PositionEntity saucer\groundshadow,x,100.5,z
		If y>100 Then HideEntity saucer\leftshadow:HideEntity saucer\rightshadow
		If y>=0 And y<=100 Then
			ShowEntity saucer\leftshadow:ShowEntity saucer\rightshadow
			PositionEntity saucer\leftshadow,-99.5,y,z
			PositionEntity saucer\rightshadow,99.5,y,z
		EndIf
		If saucer\deadmeat=True Then
			saucer\my=saucer\my-Gravity
			TurnEntity saucer\entity,saucer\dx,saucer\dy,saucer\dz
		EndIf
		If IsPointCollidingWithTrench(x,y,z)=True Then DamageSaucer(saucer,100):Goto donesaucer
		If IsPointCollidingWithTrench(x-22,y,z)=True Then DamageSaucer(saucer,100):Goto donesaucer
		If IsPointCollidingWithTrench(x+22,y,z)=True Then DamageSaucer(saucer,100):Goto donesaucer
		
		
		.donesaucer
	Next
End Function

Function DamageSaucer(saucer.saucert,dam)
	saucer\hp=saucer\hp-dam
	If saucer\hp>0 Then Return
	If saucer\hp>=-10 And saucerhp<=0 Then
		saucer\dx=Rnd(-10,10)
		saucer\dy=Rnd(-10,10)
		saucer\dz=Rnd(-10,10)
		saucer\deadmeat=True
		ChangeScore(250)
		Return
	EndIf
	x#=EntityX(saucer\entity):y#=EntityY(saucer\entity):z#=EntityZ(saucer\entity)
	AddExplosionRing(x,y,z,0,0,90,0.01,2.5,1)
	AddExplosion(x,y,z,255,255,255,0.01,1,1)	
	For a=1 To 20
		AddParticle(x,y,z,Rnd(-3,3),Rnd(0,6),Rnd(-3,3),255,255,255,-3,-3,-3,200,20,True,True)
	Next
		
	FreeEntity saucer\entity
	FreeEntity saucer\groundshadow
	FreeEntity saucer\leftshadow
	FreeEntity saucer\rightshadow
	Delete saucer
	PlaySound MediumExplosionSound
End Function

Function AddSaucerShot(x,y,z)
	ef.eft=New eft
	ef\sprite=CopyEntity(SaucerShotSprite)
	EntityType ef\sprite,Coll_saucershot
	PositionEntity ef\sprite,x,y,z
	PointEntity ef\sprite,PlayerPivot
	ef\life=100
	PlaySound SaucerShootSound
End Function

Function UpdateSaucerShots()
	For ef.eft=Each eft
		MoveEntity ef\sprite,0,0,8
		If CountCollisions(ef\sprite)>0 Then
			ShieldAlpha=0.5:DamagePlayer(1)
			cx#=CollisionX(ef\sprite,1):cy#=CollisionY(ef\sprite,1):cz#=CollisionZ(ef\sprite,1)
			AddExplosion(cx,cy,cz,255,100,0,0.05,2,False)
			For a=1 To 10
				AddParticle(cx,cy,cz,Rnd(-4,4),Rnd(-4,4),Rnd(-4,4),255,255,255,Rnd(-4,-2),Rnd(-4,-8),Rnd(-8,-16),200,5,True,False)
			Next
			PlaySound MediumExplosionSound
			FreeEntity ef\sprite:Delete ef
			Goto donesaucershot
		EndIf
		
		ef\life=ef\life-1
		If ef\life<=0 Then FreeEntity ef\sprite:Delete ef
		.donesaucershot
	Next
End Function